package custom.component
{
	import mx.containers.Canvas;
	
	
	public class CanvasCluster extends Canvas
	{
		private var drawQueue:Array;
		private var drawn:Array;
		private var maxVotes:Number;
		
		public function CanvasCluster(array:Array)
		{
			process(array);    
		}
		
		public function process(data:Array):void
		{
			var clusters:Array = data.slice(0);
			clusters.concat(data);
			drawQueue = new Array();
			while(clusters.length != 0) 
			{
				var circle:CanvasItem = clusters.splice(Math.round(Math.random()*clusters.length), 1)[0];
				if (circle) drawQueue.push(circle);
			}
			drawn = new Array();
			while (drawQueue.length) addCircle(drawQueue.shift());
			var size:Array = getMaxSize();
			if (size[1]  > 450) this.process(data);
			else 
			{
				this.height = size[1] + 50;
				this.width = size[0] + 100 + 200 + int((25*drawn.length)/size[1])*200;
				for (var h:int = 0; h < drawn.length; h++) {
					drawn[h].setXY(drawn[h].xPosition - size[2] + 25, drawn[h].yPosition - size[3] + 25);
					drawn[h].draw();
					this.addChild(drawn[h]);
				}
			}
			
		}
		
		private function addCircle (c:CanvasItem):void
		{
			if (drawn.length == 0) c.setXY(0,0);
			else
			{
				var boundingradius:Number = c.radius;
				var rndang:Number  = Math.round(Math.random()*360);
				var sinangle:Number = Math.sin(rndang * Math.PI/180);
				var cosangle:Number = Math.cos(rndang * Math.PI/180);
				c.setXY(sinangle * boundingradius, cosangle * boundingradius);
				while (!checkCollision(c))
				{
					boundingradius++;
					c.setXY(sinangle * boundingradius, cosangle * boundingradius);
				}
			}
			drawn.push(c);
		}
		
		private function checkCollision(c:CanvasItem):Boolean
		{
			for (var x:int = 0; x < drawn.length; x++)
			{
				var distfromcenter:Number = Math.sqrt(Math.pow(drawn[x].xPosition - c.xPosition,2) + Math.pow(drawn[x].yPosition - c.yPosition,2));
				if (distfromcenter <= (drawn[x].radius + c.radius)) 
				{
					return false
					break;
				}
			}
			return true;
		}
		
		private function getMaxSize():Array
		{
			var minWidth:Number = 0;
			var maxWidth:Number = 0;
			var minHeight:Number = 0;
			var maxHeight:Number = 0;
			for (var h:int = 0; h < drawn.length; h++) 
			{
				if ((drawn[h].xPosition - drawn[h].radius) < minWidth) minWidth = drawn[h].xPosition - drawn[h].radius;
				if ((drawn[h].xPosition + drawn[h].radius) > maxWidth) maxWidth = drawn[h].xPosition + drawn[h].radius;
				if ((drawn[h].yPosition - drawn[h].radius) < minHeight) minHeight = drawn[h].yPosition - drawn[h].radius;
				if ((drawn[h].yPosition + drawn[h].radius) > maxHeight) maxHeight = drawn[h].yPosition + drawn[h].radius;
			}
			return new Array(maxWidth - minWidth, maxHeight - minHeight, minWidth, minHeight);
		
		}

	}
}