package custom.component
{
	import flash.filters.DropShadowFilter;
	
	import mx.containers.Canvas;
	

	public class CanvasItem extends Canvas
	{
		public var title:String;
		public var param1:Number;
		public var param2:Number;
		public var param3:Number;
		public var radius:Number;
		public var transparency:Number;
		public var fill:Number;
		public var xPosition:Number;
		public var yPosition:Number;
		public var path:String;
		public var shadow:DropShadowFilter;
		public var source:int;
		private var colorNormal:uint;
		private var colorHighlighted:uint;

		
		public function CanvasItem(v:Number, c:Number, p:Number, cn:uint, ch:uint,t:String, pa:String)
		{
			super();
			param1 = v;
			param2 = c;
			param3 = p;
			title = t;
			path = pa;
			radius = 8;
			fill = 0;
			transparency = 0.2;
			colorNormal = cn;
			colorHighlighted = ch;
			shadow = new DropShadowFilter();
			shadow.distance = 0;
			shadow.angle = 90;
			shadow.quality = 20;
			shadow.strength = 0.8;
			shadow.inner = false;
		}
		
		public function setRadius (r:Number):void
		{
			if (r > 0) radius += 40*(param1/r);
		}
		
		public function setFill (f:Number):void
		{
			if (f > 0) fill = param2/f;
		}
		public function setAlpha (a:Number):void
		{
			if (a > 0) transparency += 0.8*(param3/a);
		}
		
		public function setXY(posX:Number, posY:Number):void
		{
			xPosition = posX;
			yPosition = posY;
			this.x = xPosition - radius;
			this.y = yPosition - radius;
		}
		
		public function draw():void
		{
			this.graphics.clear();
			this.width = radius*2;
			this.height = radius*2;
  			this.graphics.beginFill(colorNormal);
  			this.graphics.drawCircle(this.width/2,this.height/2,radius*(9/10));
  			this.graphics.beginFill(colorHighlighted);
			this.graphics.drawCircle(this.width/2,this.height/2,radius*(9/10)*(fill));
  			this.graphics.endFill();
  			//var button:Canvas = new Canvas();
  			//button.width = radius*(4/3);
  			//button.height = radius*(4/3);
  			//button.x = (this.width/2 - radius*(2/3));
  			//button.y = (this.height/2 - radius*(2/3));
  			this.toolTip = title;
  			this.alpha = transparency;
  			//this.addChild(button);
  			shadow.color = colorNormal;
  			this.filters = [shadow];
		}
		
	}
}